//==============================================================
// ʍ֘A
// STEAR 2009
//--------------------------------------------------------------

#include <pspuser.h>
#include <pspctrl.h>
#include <psputils.h>
#include <pspgu.h>
#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "intraFont.h"
#include "zenkaku.h"
#include "sime.h"
#include "draw.h"
#include "graphics.h"
#include "osk.h"

typedef struct
{
	unsigned short	u,v;
	short			x,y,z;
} Vertex;

static struct {													// monafontǗp
	char	*fontA;
	long	sizeA;
	char	*fontW;
	long	sizeW;
	int		height;
} gMona[2];

static unsigned int	__attribute__((aligned(16))) gList[1000];
static intraFont*	gJpn0;										// intraFontp
static int			gFont = 0;									// pf_print()ŎgptHg

//==============================================================
// ̍
//--------------------------------------------------------------

void HLine(int x,int y,int wx,long cor)
{
	int i;

	for (i=0; i<wx ;i++)
		VRAM[y][x+i] = cor;
}

//==============================================================
// c̍
//--------------------------------------------------------------

void VLine(int x,int y,int wy,long cor)
{
	int i;

	for (i=0; i<wy ;i++)
		VRAM[y+i][x] = cor;
}

//==============================================================
// BOX̍
//--------------------------------------------------------------

void Box(int x,int y,int wx,int wy,long corFrame)
{
	HLine(x       ,y       ,wx,corFrame);
	VLine(x       ,y       ,wy,corFrame);
	VLine(x + wx-1,y       ,wy,corFrame);
	HLine(x       ,y + wy-1,wx,corFrame);
}

//==============================================================
// hԂꂽBOX̍
//--------------------------------------------------------------
// ŏ̂PCڂCPUō悵Ac̕GUɂPCڂRs[A
// Ƃ@gĂ܂B
// ̂قCPUōs葁ۂB
//--------------------------------------------------------------

void Fill(int x,int y,int wx,int wy,long corIn)
{
	if (wx==0 || wy==0) return;
	HLine(x,y,wx,corIn);
	if (wy>1){
		sceGuStart(GU_DIRECT,gList);
		sceGuCopyImage(GU_PSM_8888, x,y,wx,wy-1,512,VRAM, x,y+1,512,VRAM);
		sceGuFinish();
		sceGuSync(0,0);
	}
}

//==============================================================
// hԂꂽBOX̍igj
//--------------------------------------------------------------

void BoxFill(int x,int y,int wx,int wy,long corFrame,long corIn)
{
	Fill(x ,y ,wx ,wy ,corIn);
	Box(x ,y ,wx ,wy ,corFrame);
}

//==============================================================
// wi]BOX̍
//--------------------------------------------------------------

void XFill(int x,int y,int wx,int wy,long corIn)
{
	int i,j;

	for (i=0; i<wy ;i++)
		for (j=0; j<wx ;j++)
			VRAM[y+i][x+j] ^= corIn;
}

//==============================================================
// pۂBOX̍igj
//--------------------------------------------------------------
// type   pۂ̑傫i0: ` 3:傫 , 4`5:Of[Vj
// corFrm g̐F
// corIn  ̐F
//---------------------------------------------------------------
// Of[Vp^[̏ꍇcorFrm̎w͖AcorInɖ邳
// ς悵܂B
// ܂AOf[Vp^[ł̍掞͓ߏs܂B
// ߏɂ graphics.c 𗘗pĂ܂B
//--------------------------------------------------------------

static void CurveBoxSub(int x,int y,int wx,long corFrm,long corIn)
{
	VRAM[y][x] = corFrm;
	HLine(x+1 ,y ,wx-2 ,corIn);
	VRAM[y][x+wx-1] = corFrm;
}

static long CurveBoxCorSet(int ar,long cor,int Alpha)
{
	unsigned long	cor1,cor2,cor3;

	cor1 = ((cor & 0x0000FF) * ar /128);
	if (cor1>0x0000FF) cor1 = 0x0000FF;
	cor2 = ((cor & 0x00FF00) * ar /128);
	if (cor2>0x00FF00) cor2 = 0x00FF00;
	cor3 = ((cor & 0x0FF0000) * ar /128);
	if (cor3>0x0FF0000) cor3 = 0x0FF0000;
	if (Alpha>0xFF) Alpha = 0xFF;
	return ( Alpha<<24 | cor1 | cor2 | cor3 );
}

static void CurveBoxSub2(int x,int y,int wx,int type,int no,long corIn,Image *source,int Alpha)
{
	const int	map1[2][7][6] = {{								// p̃p^[
					{ 0x00,0x00,0x00,0x00,0x00,0x70 },
					{ 0x00,0x00,0x00,0x00,0xFF,0xFF },
					{ 0x00,0x00,0x00,0xFF,0xD0,0xD0 },
					{ 0x00,0x00,0xFF,0xD0,0xB0,0xB0 },
					{ 0x00,0xFF,0xD0,0xB0,0x90,0x90 },
					{ 0x70,0xFF,0xD0,0xB0,0x90,0x80 },
					{ 0xFF,0xD0,0xB0,0x90,0x80,0x80 },
				},{
					{ 0x00,0x00,0x00,0x00,0x00,0x70 },
					{ 0x00,0x00,0x00,0x00,0xFF,0xFF },
					{ 0x00,0x00,0x00,0xFF,0x40,0x40 },
					{ 0x00,0x00,0xFF,0x40,0x50,0x50 },
					{ 0x00,0xFF,0x40,0x50,0x60,0x60 },
					{ 0x70,0xFF,0x40,0x50,0x60,0x70 },
					{ 0xFF,0x40,0x50,0x60,0x70,0x80 },
				}},
				map2[2][7] = {									// g̃o^[
					{ 0xFF,0xD0,0xB0,0x90,0x80,0x80,0x80 },
					{ 0xFF,0x40,0x50,0x60,0x70,0x80,0x80 },
				};
	int	i;

	if (no>5) no = 6;
	if (type>1) type = 1;

	for (i=0; i<6 ;i++){
		if (map1[type][no][i])
			source->data[y*(source->textureWidth)+i] = CurveBoxCorSet( map1[type][no][i],corIn,Alpha );
	}
	for (i=0; i<wx-12 ;i++)
		source->data[y*(source->textureWidth)+6+i] = CurveBoxCorSet( map2[type][no],corIn,Alpha );
	for (i=0; i<6 ;i++){
		if (map1[type][no][5-i])
			source->data[y*(source->textureWidth)+wx-6+i] = CurveBoxCorSet( map1[type][no][5-i],corIn,Alpha );
	}
}

void CurveBox(int x,int y,int wx,int wy,int type,long corFrm,long corIn)
{
	const int	rx[4][4] = {
					{1,0,0,0},
					{2,1,0,0},
					{3,2,1,0},
					{4,2,1,1}
				};
	Image		*source;
	int			i;


	if (type>3){
		sceGuStart(GU_DIRECT,gList);
		sceGuTexMode(GU_PSM_8888, 0, 0, 0);						// ȗintraFontgpɕ\܂
		sceGuFinish();
		source = createImage(wx,wy);
		type -= 4;
		for (i=0; i<wy ;i++){
			if (i<6){
				CurveBoxSub2( x ,i ,wx ,type ,i ,corIn ,source ,0xE0 );
			} else if (i>=wy-6){
				CurveBoxSub2( x ,i ,wx ,type ,wy -1 - i ,corIn ,source ,0xE0 );
			} else {
				CurveBoxSub2( x ,i ,wx ,type ,6 ,corIn ,source ,0xE0 );
			}
		}
		blitAlphaImageToScreen( 0, 0, wx, wy, source, x, y );
		freeImage(source);

	} else {
		for (i=0; i<wy ;i++){
			if (i==0){
				CurveBoxSub(x+rx[type][i] ,y + i ,wx-rx[type][i]*2 ,corFrm ,corFrm);
			} else if (i<4){
				CurveBoxSub(x+rx[type][i] ,y + i ,wx-rx[type][i]*2 ,corFrm ,corIn);
			} else if (i>=wy-1){
				CurveBoxSub(x+rx[type][wy-i-1] ,y + i ,wx-rx[type][wy-i-1]*2 ,corFrm ,corFrm);
			} else if (i>=wy-4){
				CurveBoxSub(x+rx[type][wy-i-1] ,y + i ,wx-rx[type][wy-i-1]*2 ,corFrm ,corIn);
			} else {
				CurveBoxSub(x ,y + i ,wx,corFrm ,corIn);
			}
		}
	}
}

//==============================================================
// ẅ0NA
//--------------------------------------------------------------

void BoxClr(int x,int y,int wx,int wy)
{
	int i;

	for (i=0; i<wy ;i++)
		HLine(x,y + i,wx,0);
}

//==============================================================
// ẅ̃Rs[
//--------------------------------------------------------------
// w肳ꂽ̈bufɎ荞
// buf͗\ߕKv+2mۂĂĂB
//--------------------------------------------------------------

void BoxCopy(long *buf,int x,int y,int wx,int wy)
{
	int i,j;

	buf[0] = wx;
	buf[1] = wy;
	for (i=0; i<wy ;i++)
		for (j=0; j<wx ;j++)
			buf[2+i*wx+j] = VRAM[y+i][x+j];
}

//==============================================================
// ẅ̃y[Xg
//--------------------------------------------------------------
// w肳ꂽʒubufWJB
//--------------------------------------------------------------

void BoxPaste(long *buf,int x,int y)
{
	int i,j;

	for (i=0; i<buf[1] ;i++)
		for (j=0; j<buf[0] ;j++)
			VRAM[y+i][x+j] = buf[2+i*buf[0]+j];
}

//==============================================================
// ʃC[W̕ۑ
//--------------------------------------------------------------
// ݂̉ʑŜҔB
// KScreenPaste()Ńobt@鎖B
//--------------------------------------------------------------

long *ScreenCopy(void)
{
	long	*buf;

	buf = (long*) malloc(sizeof(long) * (480*272+2));
	if (buf){
		BoxCopy( buf, 0, 0, 480, 272 );
	}
	return (buf);
}

//==============================================================
// ʃC[W̕ƃobt@̍폜
//--------------------------------------------------------------
// ҔĂʃC[W𕜌Aobt@폜B
// ͈񂵂ł܂B
// KScreenPaste()Ńobt@鎖B
//--------------------------------------------------------------

void ScreenPaste(long *buf)
{
	if (buf){
		BoxPaste( buf, 0, 0 );
		free(buf);
	}
}

//==============================================================
// intraFont[h
//--------------------------------------------------------------
// ߂l 0: -1:[hs
//--------------------------------------------------------------
// intraFont̓{tHgǂݍށB
// sĂȂꍇAintraFont͎g܂Biւœ_tHgg܂Bj
//--------------------------------------------------------------

int pf_setIntraFont(void)
{
	intraFontInit();											// Init intraFont library
	gJpn0 = intraFontLoad("flash0:/font/jpn0.pgf",
				INTRAFONT_STRING_SJIS | INTRAFONT_CACHE_LARGE);	// japanese font (with SJIS text string encoding)
	if (!gJpn0) return (-1);
	intraFontSetStyle( gJpn0, 0.65f, 0xFFFFFFFF, 0x00000000, 0 );
	intraFontSetEncoding( gJpn0, INTRAFONT_STRING_SJIS );

	return (0);
}

//==============================================================
// intraFontI
//--------------------------------------------------------------

void pf_endIntraFont(void)
{
	intraFontUnload(gJpn0);
	intraFontShutdown();
}

//==============================================================
// monafont[h
//--------------------------------------------------------------
// no     tHg̎ʁi0:monafont12 1:monafont16j
// pathA  ptHg̃t@C
// pathW  SptHg̃t@C
// ߂l 0: -1:[hs
//--------------------------------------------------------------
// monafontǂݍށB
// sĂȂꍇAmonafont͎g܂Biւœ_tHgg܂Bj
//--------------------------------------------------------------

int pf_setMonaFont(int no,char *pathA,char *pathW)
{
	int	fd;

	fd = sceIoOpen( pathA, PSP_O_RDONLY, 0777 );				// ptHg
	if (fd>=0){
		gMona[no].sizeA = sceIoLseek( fd, 0, SEEK_END );
		sceIoLseek( fd, 0, SEEK_SET );
		gMona[no].fontA = (char*) malloc(gMona[no].sizeA);
		if (gMona[no].fontA){
			sceIoRead( fd, gMona[no].fontA, gMona[no].sizeA );
		}
		sceIoClose(fd);
	}
	fd = sceIoOpen( pathW, PSP_O_RDONLY, 0777 );				// SptHg
	if (fd>=0){
		gMona[no].sizeW = sceIoLseek( fd, 0, SEEK_END );
		sceIoLseek( fd, 0, SEEK_SET );
		gMona[no].fontW = (char*) malloc(gMona[no].sizeW);
		if (gMona[no].fontW){
			sceIoRead( fd, gMona[no].fontW, gMona[no].sizeW );
		}
		sceIoClose(fd);
	}

	if (!gMona[no].fontA || !gMona[no].fontW){					// tHg̃[hɎsĂꍇ
		free(gMona[no].fontA);
		gMona[no].sizeA = 0;
		free(gMona[no].fontW);
		gMona[no].sizeW = 0;
		return (-1);
	}
	return (0);
}

//==============================================================
// monafont̏I
//--------------------------------------------------------------

void pf_endMonaFont(void)
{
	free(gMona[0].fontA);
	free(gMona[0].fontW);
	free(gMona[1].fontA);
	free(gMona[1].fontW);
}

//==============================================================
// tHg̃`FbN
//--------------------------------------------------------------
// w肳ꂽtHg{Ɏg邩`FbNAgȂꍇ͓_tHgɐ؂ւB
//--------------------------------------------------------------

static int chkFont(int font)
{
	if (font>4) font = 0;										// ͈͊O͓̎_tHg
	if ((font==3 || font==4) && !gJpn0) font = 0;				// intraFontgȂ
	if ((font==1 && !gMona[0].fontA) || (font==2 && !gMona[1].fontA)){
		font = 0;												// monafontgȂ
	}
	return (font);
}

//==============================================================
// tHg̎w
//--------------------------------------------------------------
// font   ̃tHgi0:_tHg    1:monafont12   2:monafont16
//                        3:intraFont   4:intraFontv|[Vij
// ߂l ۂɑIꂽtHg
//--------------------------------------------------------------
// pf_print()ŕ\ꍇ̃tHgw肷B
// w肳ꂽtHggpłȂꍇ͓_tHgg܂B
//--------------------------------------------------------------

int pf_fontType(int font)
{
	gFont = chkFont(font);
	return (gFont);
}

//==============================================================
// monafontGg[AhX̎擾
//--------------------------------------------------------------
// no     monafont̎ށi0:monafont12 1:monafont16j
// str    ŏ̈ꕶڂɎ擾
// fwidth ̉
// ߂l tHgf[^
//--------------------------------------------------------------
// w肳ꂽɑΉtHgf[^ւ̃AhX擾B
// tHgf[^̃tH[}bg
//     12hbgmonafont:(1)AtHgC[W(15)
//     16hbgmonafont:(1)AtHgC[W(16)
//
// fwidthŕԂ镶̓tHg̕ł͂ȂAʏł̐LŎlɂȂ܂B
// wtHggȂꍇNULLԂ܂B
//--------------------------------------------------------------

static unsigned short *GetMonaFont(int no,const char *str,float *fwidth)
{
	int	hi,lo,index;
	unsigned short *font;

	if (!gMona[no].fontA) return (NULL);						// tHggȂ

	if (chkSJIS(str[0])){										// SpȂ
		hi = (unsigned char) str[0];
		lo = (unsigned char) str[1];
		hi -= (hi <= 0x9f) ? 0x71 : 0xb1;
		hi <<= 1;
		hi++;
		if (lo > 0x7f)
			lo--;
		if (lo >= 0x9e){
			lo -= 0x7d;
			hi++;
		}else{
			lo -= 0x1f;
		}
		hi -= 0x21;
		lo -= 0x21;
		index = hi * (0x7e - 0x20);
		index += lo;
		if (no==0){
			if ((index << 5) >= gMona[no].sizeW){
				index = 0;
			}
			font = (unsigned short*)(gMona[no].fontW + (index<<5));
		} else {
			if ((index*34) >= gMona[no].sizeW)
				index = 0;
			font = (unsigned short*)(gMona[no].fontW + (index*34));
		}
		*fwidth = font[0];
		if (*fwidth>16) *fwidth = 16;
		if (*fwidth<0) *fwidth = 1;

	} else {													// pȂ
		index = (unsigned char) str[0];
		if ((unsigned char)str[0] < 0x20) {
			index = 0;
		} else if ((unsigned char)str[0] < 0x80) {
			index -= 0x20;
		} else if ((unsigned char)str[0] > 0xa0) {
			index -= 0x41;
		} else {
			index = 0;
		}
		if (no==0){
			if ((index << 5) >= gMona[no].sizeA) {
				index = 0;
			}
			font = (unsigned short*)(gMona[no].fontA + (index<<5));
		} else {
			if ((index *34) >= gMona[no].sizeA) {
				index = 0;
			}
			font = (unsigned short*)(gMona[no].fontA + (index*34));
		}
		*fwidth = font[0];
		if (*fwidth>16) *fwidth = 16;
		if (*fwidth<0) *fwidth = 1;
	}

	return (font);
}

//==============================================================
// monafontŕ\
//--------------------------------------------------------------
// no     monafont̎ށi0:monafont12 1:monafont16j
// ߂l Ōɕ\̏IXW
//--------------------------------------------------------------
// \XWʊOɂȂ_ŕ\͒f܂B
// ̎Ō͉̕ʊOɂ͂ݏo܂B
// \YWʊOɂȂ͍̍s܂B
// wtHggȂꍇ͍͍s܂B
//--------------------------------------------------------------

static float monaPrint(float x,int y,int no,const char *str,long cor)
{
	unsigned short	*fd,bit;
	int				sPos,fx,fy,fdw,fdh;
	float			fw;
	long			*vram;

	sPos = 0;
	if (no==0){
		fdh = 12;
	} else {
		fdh = 16;
	}
	while (str[sPos]){
		fd = GetMonaFont( no,&str[sPos], &fw );					// tHgf[^擾
		if (!fd) break;
		fdw = *fd++;											// 
		if (fdw>16) fdw = 16;
		for (fy=0; fy<fdh ;fy++){								// tHgC[W
			bit = 0x8000;
			if (y+fy>=SCR_HEIGHT) break;						// ʂ͂ݏoȂ
			vram = &VRAM[y+fy][(int)x];
			for (fx=0; fx<fdw ;fx++){
				if (*fd & bit) *vram = cor;
				vram++;
				bit >>= 1;
			}
			fd++;
		}
		x += fw;
		if (x>SCR_WIDTH) break;									// ʊOɂ͂ݏoȂ
		if (chkSJIS(str[sPos])) sPos++;
		sPos++;
	}

	return (x);
}

//==============================================================
// tHg̕\
//--------------------------------------------------------------
// ߂l \tHg̕
//--------------------------------------------------------------
// pf_fontType()Ŏw肳ꂽtHgŕ\܂B
//--------------------------------------------------------------

float pf_print(float x,int y,const char *str,long cor)
{
	return (pf_print2( x, y, gFont, str, cor ));
}

//==============================================================
// tHg̕\2
//--------------------------------------------------------------
// font   ̃tHgi0:_tHg    1:monafont12   2:monafont16
//                        3:intraFont   4:intraFontv|[Vij
// ߂l \̎̈ʒu
//--------------------------------------------------------------
// w肳ꂽtHgŕ\܂B
// wtHggȂꍇ͓_tHgg܂B
//--------------------------------------------------------------

float pf_print2(float x,int y,int font,const char *str,long cor)
{
	int	x2 = 0;

	if (font>4) font = 0;										// ͈͊O͓̎_tHg
	if (!gJpn0 && (font==3 || font==4)){						// intraFontgȂȂ
		font -= 3;												// monafontɑ
	}
	if ((font==1 && !gMona[0].fontA) || (font==2 && !gMona[1].fontA)){
		font = 0;
	}

	switch (font){
	case 0:														// monafont
		mh_print( x,y,str,cor );
		x2 = x + strlen(str) * 6;
		break;
	case 1:														// monafont12v|[Vi
		x2 = monaPrint( x,y,0,str,cor );
		break;
	case 2:														// monafont16v|[Vi
		x2 = monaPrint( x,y,1,str,cor );
		break;
	case 3:														// intraFont
		if (chkSJIS(*str)){
			guStart();
			intraFontSetStyle( gJpn0, 0.65f, cor | 0xFF000000, 0x00000000, 0 );
			intraFontPrint(gJpn0, x, y+10, str);
			sceGuFinish();
		} else {
			mh_print( x,y,str,cor );
		}
		x2 = x + strlen(str) * 6;
		break;
	case 4:														// intraFontv|[Vi
		guStart();
		intraFontSetStyle( gJpn0, 0.65f, cor | 0xFF000000, 0x00000000, 0 );
		x2 = intraFontPrint(gJpn0, x, y+10, str);
		sceGuFinish();
		break;
	}

	return (x2);
}

//==============================================================
// ̕
//--------------------------------------------------------------
// font   ̃tHgi0:_tHg    1:monafont12   2:monafont16
//                        3:intraFont   4:intraFontv|[Vij
// str    
// ߂l Lihbgj
//--------------------------------------------------------------
// ʂɕ\ۂ̕hbgPʂŎ擾B
// wtHggȂꍇ͓_tHgg܂B
// c{͏_ȉ̒[܂ōlčsƎvĂ񂾂ǁA
// ƍEXN[ɕ\ʒu1hbg̃Yoĕ␳
// Ȃ̂Ŏ~߂܂B
// [\肵̂ŁAĂ悩B
//--------------------------------------------------------------

float GetStrWidth(int font,const char *str)
{
	unsigned short	*fd;
	int				pos;
	float			w,fw;

	font = chkFont(font);										// ͈͊O͓̎_tHg

	if (font==0 || font==3){									// tHg
		w = strlen(str) * 6;
	} else if (font==4){										// intraFontv|[Vi
		w = (int) intraFontMeasureText( gJpn0,str );			// ƍ掞ɈʒuŶ
	} else {													// monafontv|[Vi
		w = 0;
		pos = 0;
		while (str[pos]){
			fd = GetMonaFont( font-1, &str[pos], &fw );
			w += fw;
			if (chkSJIS(str[pos])) pos++;
			pos++;
		}
	}
	return (w);
}

//==============================================================
// s̉
//--------------------------------------------------------------
// textsi'\n'j͂čsƍős擾B
// pf_fontType()̉e󂯂܂B
//--------------------------------------------------------------

void ChkText(int font,char *text,int *maxLen,int *line,int *wx)
{
	char	c[128];
	int		l,p,pos;

	l = 0;
	p = 0;
	*maxLen = 0;
	*line = 0;
	*wx = 0;
	pos = 0;
	while (1){													// s̊mF
		c[pos] = text[p];
		l++;
		if (text[p]=='\0' || text[p]=='\n'){
			(*line)++;
			if (*maxLen<l){
				*maxLen = l -1;
				c[pos] = '\0';
				*wx = GetStrWidth( font,c );
			}
			l = 0;
			pos = 0;
		}
		if (text[p]=='\0') break;
		p++;
		pos++;
	}
}

//==============================================================
// s̕\
//--------------------------------------------------------------
// textsi'\n'jɑΉĂ̂ŕs̕\܂B
//--------------------------------------------------------------

void DrawText(int x,int y,int font,char *text,long corStr)
{
	char	s,str[128];
	int		p,pos;

	pos = 0;
	while (text[pos]!='\0'){
		p = 0;
		while (1){												// so
			s = text[pos++];
			if (s=='\0'){
				pos--;
				break;
			}
			if (s=='\n') break;
			str[p++] = s;
		}
		str[p] = '\0';
		pf_print2(x, y, font, str, corStr);						// s\
		y += 12 +1;
	}
}

//==============================================================
// bZ[W_CAO̕\
//--------------------------------------------------------------
// textsi'\n'jɑΉĂ̂ŕs̕\܂B
// xɃ}CiX̒lw肷Ɖʒɕ\܂B
//--------------------------------------------------------------

void DiaBox1(int x,int y,int font,char *text,long corStr,long corFrm,long corIn)
{
	int len,wx,wy;

	ChkText( font, text, &len, &wy, &wx );
	wy *= 13;
	if (x<0) x = 240 - (10+wx+10)/2;
	CurveBox( x, y, 10+wx+10, 6+wy+5, 4, corFrm, corIn );
	DrawText( x+10, y+6, font, text, corStr );
}

//==============================================================
// mF_CAO̕\
//--------------------------------------------------------------
// textsi'\n'jɑΉĂ̂ŕs̕\܂B
// bZ[W̌0.5s󂯂ăL[KC_X\܂B
// xɃ}CiX̒lw肷Ɖʒɕ\܂B
//--------------------------------------------------------------

void DiaBox2(int x,int y,int font,char *text,char *key,long corStr,long corKey,long corFrm,long corIn)
{
	int		len,wx,wx2,wy;

	ChkText( font, text, &len, &wy, &wx );
	wy *= 13;
	if (x<0) x = 240 - (10+wx+10)/2;
	CurveBox( x, y, 10+wx+10, 6+wy+18+5, 4, corFrm, corIn );
	DrawText( x+10, y+6, font, text, corStr );
	wx2 = GetStrWidth( gFont,key );
	pf_print2( x+10+wx/2-wx2/2, y+6+wy+6, font, key, corKey );
}

//==============================================================
// XN[o[̕\icj
//--------------------------------------------------------------
// x,y  XN[o[ʒu
// wy   XN[o[̑傫
// pos  \ʒu
// size \TCY
// max  Ŝ̑傫
// flag 悷邩Hi0:OƓȂ悵Ȃj
//--------------------------------------------------------------

void VRollBar(int x,int y,int wy,long pos,long size,long max,int flag,long corFrm,long corIn,long corBar)
{
	long len,p;
	static long lenBuf = 0,pBuf = 0;

	if (max == 0)
		p = 0;
	else
		p = pos * (wy -2) / max;
	if (max == 0)
		len = wy -2;
	else
		len = (wy -1) * size / max +1;
	if (len > (wy -2)) len = wy -2;								// ʂ͂ݏoꍇ̕␳
	if (p + len > (wy -2)) p = wy -2 - len;						// ʂ͂ݏoꍇ̕␳

	if (lenBuf==len && pBuf==p && flag==0) return;				// OƓȂ悵Ȃ
	lenBuf = len;
	pBuf = p;

	BoxFill(x, y, 5, wy, corFrm, corIn);						// x
	Fill(x+1, y+1+p, 3, len, corBar);							// XN[o[
}

//==============================================================
// ̕\
//--------------------------------------------------------------
// x,y    \Jnʒu
// val    \liT܂Łj
// ztype  擪̋󔒂Ol߂邩i0:Ȃj
// ctype  ̎ށi0:3x5tHg 1:_tHg 2:monafont12
//                    3:monafont16  4:intraFont    5:intraFontPj
// corStr F
// ߂l \IW
//--------------------------------------------------------------

static void sv_print(int x,int y,char c,long corStr)
{
	const int font[10][15] = {{
					1,1,1,
					1,0,1,
					1,0,1,
					1,0,1,
					1,1,1,
				},{
					0,1,0,
					0,1,0,
					0,1,0,
					0,1,0,
					0,1,0,
				},{
					1,1,1,
					0,0,1,
					1,1,1,
					1,0,0,
					1,1,1,
				},{
					1,1,1,
					0,0,1,
					0,1,1,
					0,0,1,
					1,1,1,
				},{
					0,1,0,
					1,1,0,
					1,1,0,
					1,1,1,
					0,1,0,
				},{
					1,1,1,
					1,0,0,
					1,1,1,
					0,0,1,
					1,1,1,
				},{
					1,1,1,
					1,0,0,
					1,1,1,
					1,0,1,
					1,1,1,
				},{
					1,1,1,
					0,0,1,
					0,0,1,
					0,0,1,
					0,0,1,
				},{
					1,1,1,
					1,0,1,
					1,1,1,
					1,0,1,
					1,1,1,
				},{
					1,1,1,
					1,0,1,
					1,1,1,
					0,0,1,
					1,1,1,
				}};
	int i,j;

	if (c==' ') return;
	c -= '0';
	for (i=0; i<5 ;i++)
		for (j=0; j<3 ;j++)
			if (font[(int)c][i*3+j]) VRAM[y+i][x+j] = corStr;
}

static int dvsub(int x,int y,int val,int flag,int ztype,int ctype,long corStr)
{
	static char	zero;
	char		c[2] = {0,0};

	if (flag==0){
		zero = ' ';
	} else if (flag==2){
		zero = '0';
	}

	if (val!=0){												// s'0'󔒂ɕϊ邩
		zero = '0';
		c[0] = '0' + val;
	} else {
		c[0] = zero;
	}
	if (ztype && c[0]==' ') return (x);							// 󔒂̑Ol߂Ȃ
	if (ctype){
		pf_print2( x, y, ctype-1, c, corStr );
		return (x+6);
	} else {
		sv_print( x, y, c[0], corStr );
		return (x+4);
	}
}

int DrawVal(int x,int y,long val,int ztype,int ctype,long corStr)
{
	x = dvsub(x, y, (val/10000)%10, 0, ztype, ctype, corStr);
	x = dvsub(x, y, (val/1000 )%10, 1, ztype, ctype, corStr);
	x = dvsub(x, y, (val/100  )%10, 1, ztype, ctype, corStr);
	x = dvsub(x, y, (val/10   )%10, 1, ztype, ctype, corStr);
	x = dvsub(x, y, (val/1    )%10, 2, ztype, ctype, corStr);
	return (x);
}

//==============================================================
// L̕\
//--------------------------------------------------------------

void DrawChar(int x,int y,int code,long corStr)
{
	const int font[][55] = {{
					0,0,0,0,0,
					0,0,0,0,0,
					1,0,0,0,0,
					0,1,1,0,0,
					1,0,0,0,0,
					0,0,0,0,0,
					0,0,0,0,0,
					0,0,0,0,0,
					0,0,0,0,0,
					0,0,0,0,0,
					0,0,0,0,0,
				},{
					0,0,0,0,0,
					0,1,0,0,0,
					0,1,0,0,0,
					0,1,0,0,0,
					1,1,1,0,0,
					0,1,0,0,0,
					0,0,0,0,0,
					0,0,0,0,0,
					0,0,0,0,0,
					0,0,0,0,0,
					0,0,0,0,0,
				},{
					0,0,1,0,1,
					0,1,0,0,0,
					0,0,0,0,0,
					0,1,0,0,0,
					0,0,0,0,0,
					0,1,0,0,0,
					0,0,1,0,1,
					0,0,0,0,0,
					0,0,0,0,0,
					0,0,0,0,0,
					0,0,0,0,0,
				},{
					0,1,0,0,0,
					0,0,1,0,0,
					0,0,0,0,0,
					0,0,1,0,0,
					0,0,0,0,0,
					0,0,1,0,0,
					0,1,0,0,0,
					0,0,0,0,0,
					0,0,0,0,0,
					0,0,0,0,0,
					0,0,0,0,0,
				},{
					0,0,0,0,0,
					0,0,0,0,0,
					0,0,0,0,0,
					0,0,0,0,0,
					1,0,0,0,0,
					0,1,1,0,0,
					1,0,0,0,0,
					0,0,0,0,0,
					0,0,0,0,0,
					0,0,0,0,0,
					0,0,0,0,0,
				},{
					0,0,0,0,0,
					0,0,0,0,0,
					0,0,1,0,0,
					0,0,1,0,0,
					0,0,1,0,0,
					0,0,1,0,0,
					1,0,1,0,1,
					0,1,1,1,0,
					0,0,1,0,0,
					0,0,0,0,0,
					0,0,0,0,0,
				},{
					0,0,1,0,1,
					0,1,0,0,0,
					0,0,0,0,0,
					0,1,0,0,0,
					0,0,0,0,0,
					0,1,0,0,0,
					0,0,0,0,0,
					0,1,0,0,0,
					0,0,0,0,0,
					0,1,0,0,0,
					0,0,1,0,1,
				},{
					0,1,0,1,0,
					0,0,0,0,1,
					0,0,0,0,0,
					0,0,0,0,1,
					0,0,0,0,0,
					0,0,0,0,1,
					0,0,0,0,0,
					0,0,0,0,1,
					0,0,0,0,0,
					0,0,0,0,1,
					0,1,0,1,0,
				}};
	int i,j;

	for (i=0; i<11 ;i++)
		for (j=0; j<5 ;j++)
			if (font[code][i*5+j]) VRAM[y+i][x+j] = corStr;
}

